



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>js 中创建对象</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">js 中创建对象</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 21:00:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>对象是什么</h3>
<p>从JavaScript定义上讲对象是无序属性的集合，其属性可以包含基本值、对象或函数。也就是说对象是一组没有特定顺序的属性，每个属性会映射到一个值上，是一组键值对，值可以是数据或对象。</p>
<h3>最简单的对象</h3>
<p>JavaScript的一对花括号{}就可以定义一个对象，这样的写法实际上和调用Object的构造函数一样</p>
<div>
<pre class="prettyprint linenums">var obj={};<br />
var obj2=new Object();
</pre>
</div>
<p>　　</p>
<p>这样构建出来的对象仅仅包含一个指向Object的prototype的指针，可以使用一些valueOf、hasQwnProperty等方法，没有多大实际作用，自定义对象嘛总要有一些自定义的属性、方法神马的。</p>
<div>
<pre class="prettyprint linenums">var obj={};<br />
            obj.a=0;<br />
            obj.fn=function(){<br />
                alert(this);<br />
            }

            var obj2={<br />
                a:0,<br />
                fn:function(){<br />
                    alert(this);<br />
                }<br />
            }
</pre>
</div>
<p>　　</p>
<p>可以在定义完对象后通过&rdquo;.&rdquo;为其添加属性和方法，也可以使用字面量赋值方法在定义对象的时候为其添加属性和方法，这样创建的对象，其方法和属性可以直接使用对象引用，类似于类的静态变量和静态函数，这样创建对象有一个明显缺陷&mdash;&mdash;在定义大量对象的时候很费力，要一遍遍的写几乎是重复的代码。</p>
<h3>抽象一下</h3>
<p>既然是重复代码就可以抽象出来，用函数来做这些重复工作，在创建对象的时候调用一个专门创建对象的方法，对于不同的属性值只需要传入不同参数即可。</p>
<div>
<pre class="prettyprint linenums">function createObj(a,fn){<br />
                var obj={};<br />
                obj.a=a;<br />
                obj.fn=fn;<br />
                return obj;<br />
            }

            var obj=createObj(2,function(){<br />
                alert(this.a);<br />
            });
</pre>
</div>
<p>　　</p>
<p>这里先定义o为一个空的对象，然后为o设置了一堆属性。其实也可以直接给o属性的嘛，所以如果这样写也是ok的。</p>
<div>
<pre class="prettyprint linenums">function createPerson(name,age,job){<br />
    var o = {};<br />
    o.name = name;<br />
    o.age = age;<br />
    o.job = job;<br />
    o.sayName = function(){<br />
     alert(this.name);<br />
    };<br />
    return o;<br />
}

var tanya = createPerson("tanya","30","female");<br />
var ansel = createPerson("ansel","30","male");

tanya.sayName();<br />
ansel.sayName();
</pre>
</div>
<p>　　还有一种办法是利用无敌的this，因为this就表示当前运行时的对象，将构造函数this的作用域指向新对象，将当前运行对象的属性和方法都赋给新对象，这样对象模式称为构造函数模式</p>
<div>
<pre class="prettyprint linenums">function Person(name,age,job){<br />
    this.name = name;<br />
    this.age = age;<br />
    this.job = job;<br />
    this.sayName = function(){<br />
     alert(this.name);<br />
    };<br />
}

var tanya = new Person("tanya","30","female");<br />
var ansel =  new Person("ansel","30","male");

tanya.sayName();<br />
ansel.sayName();
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvz5ro9.html">编写一个简单的jdbc例子程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9px7ydq.html">redis &plus;  spring 集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4kd39.html">HDU 5015</a>
		</li>
						<li><a href="https://www.batexi.com/a/49grvv0q.html">Hibernate&lpar;九&rpar;&lowbar;&lowbar;OpenSessionInView解决懒加载问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96nmz4q.html">Shell 之外 试试不操作 shell 来实现同样的效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7kmv19.html">BlocksKit初见&colon;一个支持将delegate转换成block的Cocoa库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e16gyj9.html">javascript判断设备类型-手机&lpar;mobile&rpar;、安卓&lpar;android&rpar;、电脑&lpar;pc&rpar;、其他&lpar;ipad&sol;iPod&sol;Windows&rpar;等</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zn02e9.html">云计算之路-阿里云上：RDS数据库连接数过万引发故障，主备库切换后恢复正常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkg1ne8.html">java虚拟机构造原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge76z08.html">MonacoEditor 主动触发代码提示功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdkrod9.html">&lbrack;剑指Offer&rsqb;29-顺时针打印矩阵-Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1vdre9.html">大道至简第一章读后感JAVA伪代码形式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gy6wzq.html">【BZOJ3879】SvT（后缀自动机，虚树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j144kg9.html">MS11-050安全漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk1olx8.html">BZOJ 1565 &lbrack;NOI2009&rsqb;植物大战僵尸 &vert; 网络流</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kjjyxq.html">使用WindowsAPICodePack实现翻译功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2221e8.html">Python的可视化包 &ndash; Matplotlib  2D图表&lpar;点图和线图&comma;&period;柱状或饼状类型的图&rpar;&comma;3D图表&lpar;曲面图，散点图和柱状图&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p4zmjq.html">SpringMVC -- 梗概--源码--贰--下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppm4v79.html">UVA 11768 - Lattice Point or Not</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4oeolq.html">《逆袭大学：传给IT学子的正能量》</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eymjrk9.html">openstack私有云布署实践【16&period;3 Windows Server2008 R2 只有C盘分区镜像制作】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mejw42q.html">（一）初步了解python</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jk2z38.html">StringBuffer使用append提示String concatenation as argument to &amp;&num;39&semi;StringBuffer&period;append&lpar;&rpar;&amp;&num;39&semi; call</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m2y7m8.html">python向服务器发送邮件事例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjln7y8.html">Jstorm调度定制化接口&lpar;0&period;9&period;5 及高版本&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ze0ge9.html">UNIX基础--进程和守护进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgnk7m8.html">查看Oracle正在执行的任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geprl78.html">PortMon&lpar;电脑开放端口检查工具&rpar; 3&period;03 免费绿色版</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jk66w8.html">ucenter无法双向同步setting&lbrack;allowsynlogin&rsqb;为0问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjnknk8.html">Java语法基础总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
